//--------------------------------------------------------------------------
// TYPES OF ALLOWED DAMAGE
//--------------------------------------------------------------------------

$DamageType::Default       = 0;
$DamageTypeName[$DamageType::Default] = "Default";
$DamageType::Energy        = 1;
$DamageTypeName[$DamageType::Energy] = "Energy Based";
$DamageType::Fire          = 2;
$DamageTypeName[$DamageType::Fire] = "Fire Based";
$DamageType::Bullet        = 3;
$DamageTypeName[$DamageType::Bullet] = "Bullet Based";
$DamageType::Explosion     = 4;
$DamageTypeName[$DamageType::Explosion] = "Explosion Based";
$DamageType::Explosion     = 5;
$DamageTypeName[$DamageType::HighExplosion] = "Explosion Based";
$DamageType::Electricity   = 6;
$DamageTypeName[$DamageType::Electricity] = "Electricity Based";
$DamageType::Laser         = 7;
$DamageTypeName[$DamageType::Laser] = "Laser Based";
$DamageType::Impact        = 8;
$DamageTypeName[$DamageType::Impact] = "Struck by Something";
$DamageType::Ground        = 9;
$DamageTypeName[$DamageType::Ground] = "Struck Something";
$DamageType::Water         = 10;
$DamageTypeName[$DamageType::Water] = "Struck Water";

$DamageType::Lightning     = 11;
$DamageTypeName[$DamageType::Lightning] = "Struck by Lightning";
$DamageType::Lava  = 12;
$DamageTypeName[$DamageType::Lava] = "Entered Lava";
$DamageType::VehicleSpawn  = 13;
$DamageTypeName[$DamageType::VehicleSpawn] = "Vehicle Spawn";

// DMM -- added so MPBs that blow up under water get a message
//$DamageType::Water                    = 97;

//Tinman - used in Hunters for cheap bastards  ;)
$DamageType::NexusCamping		= 98;

// MES -- added so CTRL-K can get a distinctive message
$DamageType::Suicide			= 99;

// --------------------------------------------------------------------------
// Universal for Shielding
// --------------------------------------------------------------------------

$shieldDamageScale[$DamageType::Default]       = 1.0;
$shieldDamageScale[$DamageType::Energy]        = 1.8;
$shieldDamageScale[$DamageType::Fire]          = 0.8;
$shieldDamageScale[$DamageType::Bullet]        = 1.25;
$shieldDamageScale[$DamageType::Explosion]     = 0.8;
$shieldDamageScale[$DamageType::HighExplosion] = 2.0;
$shieldDamageScale[$DamageType::Electricity]   = 2.0;
$shieldDamageScale[$DamageType::Laser]         = 2.0;
$shieldDamageScale[$DamageType::Impact]        = 0.7;
$shieldDamageScale[$DamageType::Ground]        = 0.5;
$shieldDamageScale[$DamageType::Water]         = 2.0;
$shieldDamageScale[$DamageType::lightning]     = 4.5;

//----------------------------------------------------------------------------
// VEHICLE DAMAGE PROFILES
//----------------------------------------------------------------------------

//**** WILDCAT GRAV CYCLE ****
datablock SimDataBlock(WildcatDamageProfile)
{
   damageScale[$DamageType::Default]          = 1.0;
   damageScale[$DamageType::Energy]           = 0.95;
   damageScale[$DamageType::Fire]             = 0.85;
   damageScale[$DamageType::Bullet]           = 1.3;
   damageScale[$DamageType::Explosion]        = 1.05;
   damageScale[$DamageType::HighExplosion]    = 1.5;
   damageScale[$DamageType::Electricity]      = 0.45;
   damageScale[$DamageType::Laser]            = 1.25;
   damageScale[$DamageType::Impact]           = 1.2;
   damageScale[$DamageType::Ground]           = 1.25;
   damageScale[$DamageType::Water]            = 0.2;
   damageScale[$DamageType::lightning]        = 1.2;
};

//**** SHRIKE SCOUT FIGHTER ****
datablock SimDataBlock(ShrikeDamageProfile)
{
   damageScale[$DamageType::Default]          = 1.0;
   damageScale[$DamageType::Energy]           = 0.8;
   damageScale[$DamageType::Fire]             = 0.75;
   damageScale[$DamageType::Bullet]           = 1.2;
   damageScale[$DamageType::Explosion]        = 1.15;
   damageScale[$DamageType::HighExplosion]    = 1.4;
   damageScale[$DamageType::Electricity]      = 0.4;
   damageScale[$DamageType::Laser]            = 1.2;
   damageScale[$DamageType::Impact]           = 1.0;
   damageScale[$DamageType::Ground]           = 1.15;
   damageScale[$DamageType::Water]            = 1.6;
   damageScale[$DamageType::lightning]        = 1.3;
};

//**** THUNDERSWORD BOMBER ****
datablock SimDataBlock(BomberDamageProfile)
{
   damageScale[$DamageType::Default]          = 1.0;
   damageScale[$DamageType::Energy]           = 0.75;
   damageScale[$DamageType::Fire]             = 0.65;
   damageScale[$DamageType::Bullet]           = 1.15;
   damageScale[$DamageType::Explosion]        = 1.05;
   damageScale[$DamageType::HighExplosion]    = 1.3;
   damageScale[$DamageType::Electricity]      = 0.25;
   damageScale[$DamageType::Laser]            = 1.15;
   damageScale[$DamageType::Impact]           = 0.85;
   damageScale[$DamageType::Ground]           = 1.1;
   damageScale[$DamageType::Water]            = 1.4;
   damageScale[$DamageType::lightning]        = 1.35;
};

//**** HAVOC TRANSPORT ****
datablock SimDataBlock(HavocDamageProfile)
{
   damageScale[$DamageType::Default]          = 1.0;
   damageScale[$DamageType::Energy]           = 0.72;
   damageScale[$DamageType::Fire]             = 0.62;
   damageScale[$DamageType::Bullet]           = 1.12;
   damageScale[$DamageType::Explosion]        = 1.04;
   damageScale[$DamageType::HighExplosion]    = 1.26;
   damageScale[$DamageType::Electricity]      = 0.22;
   damageScale[$DamageType::Laser]            = 1.12;
   damageScale[$DamageType::Impact]           = 0.8;
   damageScale[$DamageType::Ground]           = 1.1;
   damageScale[$DamageType::Water]            = 1.35;
   damageScale[$DamageType::lightning]        = 1.38;
};


//**** JERICHO MPB ****
datablock SimDataBlock(MPBDamageProfile)
{
   damageScale[$DamageType::Default]          = 1.00;
   damageScale[$DamageType::Energy]           = 0.70;
   damageScale[$DamageType::Fire]             = 0.28;
   damageScale[$DamageType::Bullet]           = 0.40;
   damageScale[$DamageType::Explosion]        = 0.8;
   damageScale[$DamageType::HighExplosion]    = 1.50;
   damageScale[$DamageType::Electricity]      = 0.20;
   damageScale[$DamageType::Laser]            = 0.95;
   damageScale[$DamageType::Impact]           = 0.50;
   damageScale[$DamageType::Ground]           = 0.80;
   damageScale[$DamageType::Water]            = 10.0;
   damageScale[$DamageType::lightning]        = 1.40;
};

//**** BEOWULF TANK ****
datablock SimDataBlock(TankDamageProfile)
{
   damageScale[$DamageType::Default]          = 1.00;
   damageScale[$DamageType::Energy]           = 0.65;
   damageScale[$DamageType::Fire]             = 0.25;
   damageScale[$DamageType::Bullet]           = 0.35;
   damageScale[$DamageType::Explosion]        = 0.85;
   damageScale[$DamageType::HighExplosion]    = 1.40;
   damageScale[$DamageType::Electricity]      = 0.18;
   damageScale[$DamageType::Laser]            = 0.80;
   damageScale[$DamageType::Impact]           = 0.65;
   damageScale[$DamageType::Ground]           = 0.75;
   damageScale[$DamageType::Water]            = 0.20;
   damageScale[$DamageType::lightning]        = 1.45;
};

//----------------------------------------------------------------------------
// TURRET DAMAGE PROFILES
//----------------------------------------------------------------------------

datablock SimDataBlock(TurretDamageProfile)
{
   damageScale[$DamageType::Default]          = 1.0;
   damageScale[$DamageType::Energy]           = 0.9;
   damageScale[$DamageType::Fire]             = 0.85;
   damageScale[$DamageType::Bullet]           = 1.25;
   damageScale[$DamageType::Explosion]        = 1.12;
   damageScale[$DamageType::HighExplosion]    = 1.45;
   damageScale[$DamageType::Electricity]      = 0.65;
   damageScale[$DamageType::Laser]            = 1.25;
   damageScale[$DamageType::Impact]           = 1.0;
   damageScale[$DamageType::Ground]           = 0.8;
   damageScale[$DamageType::Water]            = 0.2;
   damageScale[$DamageType::lightning]        = 0.2;
};

//----------------------------------------------------------------------------
// STATIC SHAPE DAMAGE PROFILES
//----------------------------------------------------------------------------

datablock SimDataBlock(StaticShapeDamageProfile)
{
   damageScale[$DamageType::Default]          = 1.0;
   damageScale[$DamageType::Energy]           = 0.9;
   damageScale[$DamageType::Fire]             = 0.85;
   damageScale[$DamageType::Bullet]           = 1.25;
   damageScale[$DamageType::Explosion]        = 1.12;
   damageScale[$DamageType::HighExplosion]    = 1.45;
   damageScale[$DamageType::Electricity]      = 0.65;
   damageScale[$DamageType::Laser]            = 1.25;
   damageScale[$DamageType::Impact]           = 1.0;
   damageScale[$DamageType::Ground]           = 0.8;
   damageScale[$DamageType::Water]            = 0.2;
   damageScale[$DamageType::lightning]        = 0.2;
};

//----------------------------------------------------------------------------
// PLAYER DAMAGE PROFILES
//----------------------------------------------------------------------------

// --------------------------------------------------------------------------
// Universal for Shielding
// --------------------------------------------------------------------------

$rearDamageScale[$DamageType::Default]       = 1.0;
$rearDamageScale[$DamageType::Energy]        = 1.25;
$rearDamageScale[$DamageType::Fire]          = 1.0;
$rearDamageScale[$DamageType::Bullet]        = 1.22;
$rearDamageScale[$DamageType::Explosion]     = 1.15;
$rearDamageScale[$DamageType::HighExplosion] = 1.0;
$rearDamageScale[$DamageType::Electricity]   = 1.2;
$rearDamageScale[$DamageType::Laser]         = 1.2;
$rearDamageScale[$DamageType::Impact]        = 1.0;
$rearDamageScale[$DamageType::Ground]        = 1.0;
$rearDamageScale[$DamageType::Water]         = 1.0;
$rearDamageScale[$DamageType::lightning]     = 1.5;

// Light armor is the basis for everything.  Everything is measured by how it 
// reacts to things

datablock SimDataBlock(LightPlayerDamageProfile)
{
   damageScale[$DamageType::Default]          = 1.0;
   damageScale[$DamageType::Energy]           = 1.0;
   damageScale[$DamageType::Fire]             = 1.0;
   damageScale[$DamageType::Bullet]           = 1.0;
   damageScale[$DamageType::Explosion]        = 1.0;
   damageScale[$DamageType::HighExplosion]    = 0.6;
   damageScale[$DamageType::Electricity]      = 1.0;
   damageScale[$DamageType::Laser]            = 1.0;
   damageScale[$DamageType::Impact]           = 1.0;
   damageScale[$DamageType::Ground]           = 1.0;
   damageScale[$DamageType::Water]            = 1.0;
   damageScale[$DamageType::lightning]        = 1.0;
};

datablock SimDataBlock(AdrenPlayerDamageProfile)
{
   damageScale[$DamageType::Default]          = 0.92;
   damageScale[$DamageType::Energy]           = 0.92;
   damageScale[$DamageType::Fire]             = 0.92;
   damageScale[$DamageType::Bullet]           = 0.92;
   damageScale[$DamageType::Explosion]        = 0.92
   damageScale[$DamageType::HighExplosion]    = 0.54;
   damageScale[$DamageType::Electricity]      = 0.92;
   damageScale[$DamageType::Laser]            = 0.92;
   damageScale[$DamageType::Impact]           = 0.92;
   damageScale[$DamageType::Ground]           = 0.92;
   damageScale[$DamageType::Water]            = 0.92;
   damageScale[$DamageType::lightning]        = 0.92;
};

datablock SimDataBlock(MediumPlayerDamageProfile)
{
   damageScale[$DamageType::Default]          = 1.0;
   damageScale[$DamageType::Energy]           = 1.0;
   damageScale[$DamageType::Fire]             = 0.94;
   damageScale[$DamageType::Bullet]           = 0.8;
   damageScale[$DamageType::Explosion]        = 0.94;
   damageScale[$DamageType::HighExplosion]    = 0.5;
   damageScale[$DamageType::Electricity]      = 1.05;
   damageScale[$DamageType::Laser]            = 0.94;
   damageScale[$DamageType::Impact]           = 0.94;
   damageScale[$DamageType::Ground]           = 0.94;
   damageScale[$DamageType::Water]            = 1.2;
   damageScale[$DamageType::lightning]        = 1.05;
};

datablock SimDataBlock(EngineerPlayerDamageProfile)
{
   damageScale[$DamageType::Default]          = 1.0;
   damageScale[$DamageType::Energy]           = 1.0;
   damageScale[$DamageType::Fire]             = 0.98;
   damageScale[$DamageType::Bullet]           = 0.85;
   damageScale[$DamageType::Explosion]        = 0.98;
   damageScale[$DamageType::HighExplosion]    = 0.6;
   damageScale[$DamageType::Electricity]      = 1.08;
   damageScale[$DamageType::Laser]            = 0.98;
   damageScale[$DamageType::Impact]           = 0.90;
   damageScale[$DamageType::Ground]           = 0.90;
   damageScale[$DamageType::Water]            = 1.3;
   damageScale[$DamageType::lightning]        = 1.08;
};

datablock SimDataBlock(HeavyPlayerDamageProfile)
{
   damageScale[$DamageType::Default]          = 1.0;
   damageScale[$DamageType::Energy]           = 1.0;
   damageScale[$DamageType::Fire]             = 0.86;
   damageScale[$DamageType::Bullet]           = 0.65;
   damageScale[$DamageType::Explosion]        = 0.86;
   damageScale[$DamageType::HighExplosion]    = 0.4;
   damageScale[$DamageType::Electricity]      = 1.11;
   damageScale[$DamageType::Laser]            = 0.86;
   damageScale[$DamageType::Impact]           = 0.86;
   damageScale[$DamageType::Ground]           = 0.86;
   damageScale[$DamageType::Water]            = 1.35;
   damageScale[$DamageType::lightning]        = 1.11;
};
